using System;
using Lesnikowski.Mail;									// Email parser
using Lesnikowski.Client;								// POP3 and SMTP clients

class SimpleExample1
{
	private static void Receive()
	{
		Pop3 pop3 = new Pop3();
		pop3.User = "lesnikowski";                        // Set user name and password
		pop3.Password = "password";

		try
		{
			pop3.Connect("mail.host.com");              // Connect to server and login
			pop3.Login();
			pop3.GetAccountStat();                      // Get account statistics

			for(int i = 1; i <= pop3.MessageCount; i++)
			{
				try										
				{
					// Receive email
					SimpleMailMessage simpleMail;
					simpleMail = SimpleMailMessage.Parse( pop3.GetMessage(i) );

					// Write out received message
					Console.WriteLine( "-- email {0} --", i);
                    Console.WriteLine( simpleMail.Subject );
                    Console.WriteLine( simpleMail.TextDataString );

					// Use other properties to access email data
				}
				catch(MailException ex)
				{
					Console.WriteLine( ex.Message );    // Invalid email format
				}
			}
		}							
		catch(ServerException ex)
		{
			Console.WriteLine( ex.Message );            // Server error
		}
		finally
		{
			pop3.Close(false);                          // Close connection
		}
		Console.WriteLine( "Receiving completed.\nPress enter..." );
		Console.ReadLine();
	}
};
