using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Text;

using Lesnikowski.Mail;
using Lesnikowski.Client;

public class MainForm : System.Windows.Forms.Form
{
	private MailMessage mail=null;
	private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
	private System.Windows.Forms.MainMenu mainMenu;
	private System.Windows.Forms.MenuItem selectFolderMenuItem;
	private System.Windows.Forms.StatusBar statusBar;
	private System.Windows.Forms.Splitter splitter1;
	private System.Windows.Forms.Panel panel1;
	private System.Windows.Forms.Splitter splitter2;
	private System.Windows.Forms.Panel panel2;
	private System.Windows.Forms.ListView mailListView;
	private System.Windows.Forms.TreeView mimeTreeView;
	private System.Windows.Forms.Button saveButton;
	private System.Windows.Forms.Panel panel3;
	private System.Windows.Forms.TextBox textBox;
	private System.Windows.Forms.PictureBox pictureBox;
	private System.Windows.Forms.Panel mailPanel;
	private System.Windows.Forms.TextBox subject;
	private System.Windows.Forms.TextBox from;
	private System.Windows.Forms.Label label1;
	private System.Windows.Forms.Label label2;
	private System.Windows.Forms.Label label3;
	private System.Windows.Forms.Label label4;
	private System.Windows.Forms.Button simpleViewButton;
	private System.Windows.Forms.ListBox toListBox;
	private System.Windows.Forms.ListBox ccListBox;
	private System.Windows.Forms.MenuItem receiveMenuItem;
	private System.Windows.Forms.Button errorListButton;
	private System.Windows.Forms.MenuItem localMenuItem;
	private System.Windows.Forms.MenuItem serverMenuItem;
	private System.ComponentModel.Container components = null;

	public MainForm()
	{
		InitializeComponent();
		this.mailPanel.Dock=DockStyle.Fill;
		this.pictureBox.Dock=DockStyle.Fill;
		this.textBox.Dock=DockStyle.Fill;
	}

	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if (components != null) 
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
		this.mainMenu = new System.Windows.Forms.MainMenu();
		this.localMenuItem = new System.Windows.Forms.MenuItem();
		this.selectFolderMenuItem = new System.Windows.Forms.MenuItem();
		this.serverMenuItem = new System.Windows.Forms.MenuItem();
		this.receiveMenuItem = new System.Windows.Forms.MenuItem();
		this.statusBar = new System.Windows.Forms.StatusBar();
		this.mailListView = new System.Windows.Forms.ListView();
		this.splitter1 = new System.Windows.Forms.Splitter();
		this.panel1 = new System.Windows.Forms.Panel();
		this.panel3 = new System.Windows.Forms.Panel();
		this.mailPanel = new System.Windows.Forms.Panel();
		this.ccListBox = new System.Windows.Forms.ListBox();
		this.toListBox = new System.Windows.Forms.ListBox();
		this.label4 = new System.Windows.Forms.Label();
		this.label3 = new System.Windows.Forms.Label();
		this.label2 = new System.Windows.Forms.Label();
		this.label1 = new System.Windows.Forms.Label();
		this.from = new System.Windows.Forms.TextBox();
		this.subject = new System.Windows.Forms.TextBox();
		this.pictureBox = new System.Windows.Forms.PictureBox();
		this.textBox = new System.Windows.Forms.TextBox();
		this.panel2 = new System.Windows.Forms.Panel();
		this.errorListButton = new System.Windows.Forms.Button();
		this.simpleViewButton = new System.Windows.Forms.Button();
		this.saveButton = new System.Windows.Forms.Button();
		this.splitter2 = new System.Windows.Forms.Splitter();
		this.mimeTreeView = new System.Windows.Forms.TreeView();
		this.panel1.SuspendLayout();
		this.panel3.SuspendLayout();
		this.mailPanel.SuspendLayout();
		this.panel2.SuspendLayout();
		this.SuspendLayout();
		// 
		// folderBrowserDialog
		// 
		this.folderBrowserDialog.SelectedPath = "D:\\jezyki\\vsnet\\programy\\Mail3\\eml";
		this.folderBrowserDialog.ShowNewFolderButton = false;
		// 
		// mainMenu
		// 
		this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				 this.localMenuItem,
																				 this.serverMenuItem});
		// 
		// localMenuItem
		// 
		this.localMenuItem.Index = 0;
		this.localMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.selectFolderMenuItem});
		this.localMenuItem.Text = "&Local";
		// 
		// selectFolderMenuItem
		// 
		this.selectFolderMenuItem.Index = 0;
		this.selectFolderMenuItem.Text = "&Select folder...";
		this.selectFolderMenuItem.Click += new System.EventHandler(this.selectFolderMenuItem_Click);
		// 
		// serverMenuItem
		// 
		this.serverMenuItem.Index = 1;
		this.serverMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.receiveMenuItem});
		this.serverMenuItem.Text = "&Server";
		// 
		// receiveMenuItem
		// 
		this.receiveMenuItem.Index = 0;
		this.receiveMenuItem.Text = "Receive...";
		this.receiveMenuItem.Click += new System.EventHandler(this.receiveMenuItem_Click);
		// 
		// statusBar
		// 
		this.statusBar.Location = new System.Drawing.Point(0, 427);
		this.statusBar.Name = "statusBar";
		this.statusBar.ShowPanels = true;
		this.statusBar.Size = new System.Drawing.Size(728, 22);
		this.statusBar.TabIndex = 0;
		// 
		// mailListView
		// 
		this.mailListView.Dock = System.Windows.Forms.DockStyle.Left;
		this.mailListView.Location = new System.Drawing.Point(0, 0);
		this.mailListView.MultiSelect = false;
		this.mailListView.Name = "mailListView";
		this.mailListView.Size = new System.Drawing.Size(200, 427);
		this.mailListView.Sorting = System.Windows.Forms.SortOrder.Ascending;
		this.mailListView.TabIndex = 1;
		this.mailListView.View = System.Windows.Forms.View.List;
		this.mailListView.SelectedIndexChanged += new System.EventHandler(this.mailListView_SelectedIndexChanged);
		// 
		// splitter1
		// 
		this.splitter1.Location = new System.Drawing.Point(200, 0);
		this.splitter1.Name = "splitter1";
		this.splitter1.Size = new System.Drawing.Size(3, 427);
		this.splitter1.TabIndex = 2;
		this.splitter1.TabStop = false;
		// 
		// panel1
		// 
		this.panel1.Controls.Add(this.panel3);
		this.panel1.Controls.Add(this.panel2);
		this.panel1.Controls.Add(this.splitter2);
		this.panel1.Controls.Add(this.mimeTreeView);
		this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
		this.panel1.Location = new System.Drawing.Point(203, 0);
		this.panel1.Name = "panel1";
		this.panel1.Size = new System.Drawing.Size(525, 427);
		this.panel1.TabIndex = 3;
		// 
		// panel3
		// 
		this.panel3.Controls.Add(this.mailPanel);
		this.panel3.Controls.Add(this.pictureBox);
		this.panel3.Controls.Add(this.textBox);
		this.panel3.Dock = System.Windows.Forms.DockStyle.Fill;
		this.panel3.Location = new System.Drawing.Point(0, 155);
		this.panel3.Name = "panel3";
		this.panel3.Size = new System.Drawing.Size(525, 224);
		this.panel3.TabIndex = 3;
		// 
		// mailPanel
		// 
		this.mailPanel.Controls.Add(this.ccListBox);
		this.mailPanel.Controls.Add(this.toListBox);
		this.mailPanel.Controls.Add(this.label4);
		this.mailPanel.Controls.Add(this.label3);
		this.mailPanel.Controls.Add(this.label2);
		this.mailPanel.Controls.Add(this.label1);
		this.mailPanel.Controls.Add(this.from);
		this.mailPanel.Controls.Add(this.subject);
		this.mailPanel.Location = new System.Drawing.Point(48, 16);
		this.mailPanel.Name = "mailPanel";
		this.mailPanel.Size = new System.Drawing.Size(408, 192);
		this.mailPanel.TabIndex = 2;
		// 
		// ccListBox
		// 
		this.ccListBox.Location = new System.Drawing.Point(56, 136);
		this.ccListBox.Name = "ccListBox";
		this.ccListBox.Size = new System.Drawing.Size(336, 43);
		this.ccListBox.TabIndex = 9;
		// 
		// toListBox
		// 
		this.toListBox.Location = new System.Drawing.Point(56, 80);
		this.toListBox.Name = "toListBox";
		this.toListBox.Size = new System.Drawing.Size(336, 43);
		this.toListBox.TabIndex = 8;
		// 
		// label4
		// 
		this.label4.Location = new System.Drawing.Point(8, 136);
		this.label4.Name = "label4";
		this.label4.Size = new System.Drawing.Size(40, 16);
		this.label4.TabIndex = 7;
		this.label4.Text = "cc:";
		// 
		// label3
		// 
		this.label3.Location = new System.Drawing.Point(8, 80);
		this.label3.Name = "label3";
		this.label3.Size = new System.Drawing.Size(40, 16);
		this.label3.TabIndex = 5;
		this.label3.Text = "to:";
		// 
		// label2
		// 
		this.label2.Location = new System.Drawing.Point(8, 48);
		this.label2.Name = "label2";
		this.label2.Size = new System.Drawing.Size(40, 16);
		this.label2.TabIndex = 4;
		this.label2.Text = "from:";
		// 
		// label1
		// 
		this.label1.Location = new System.Drawing.Point(8, 16);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(48, 16);
		this.label1.TabIndex = 3;
		this.label1.Text = "subject:";
		// 
		// from
		// 
		this.from.Location = new System.Drawing.Point(56, 48);
		this.from.Name = "from";
		this.from.Size = new System.Drawing.Size(336, 20);
		this.from.TabIndex = 1;
		this.from.Text = "";
		// 
		// subject
		// 
		this.subject.Location = new System.Drawing.Point(56, 16);
		this.subject.Name = "subject";
		this.subject.Size = new System.Drawing.Size(336, 20);
		this.subject.TabIndex = 0;
		this.subject.Text = "";
		// 
		// pictureBox
		// 
		this.pictureBox.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
		this.pictureBox.Location = new System.Drawing.Point(24, 120);
		this.pictureBox.Name = "pictureBox";
		this.pictureBox.Size = new System.Drawing.Size(100, 96);
		this.pictureBox.TabIndex = 1;
		this.pictureBox.TabStop = false;
		// 
		// textBox
		// 
		this.textBox.Location = new System.Drawing.Point(16, 64);
		this.textBox.Multiline = true;
		this.textBox.Name = "textBox";
		this.textBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
		this.textBox.Size = new System.Drawing.Size(100, 96);
		this.textBox.TabIndex = 0;
		this.textBox.Text = "";
		// 
		// panel2
		// 
		this.panel2.Controls.Add(this.errorListButton);
		this.panel2.Controls.Add(this.simpleViewButton);
		this.panel2.Controls.Add(this.saveButton);
		this.panel2.Dock = System.Windows.Forms.DockStyle.Bottom;
		this.panel2.Location = new System.Drawing.Point(0, 379);
		this.panel2.Name = "panel2";
		this.panel2.Size = new System.Drawing.Size(525, 48);
		this.panel2.TabIndex = 2;
		// 
		// errorListButton
		// 
		this.errorListButton.Location = new System.Drawing.Point(128, 16);
		this.errorListButton.Name = "errorListButton";
		this.errorListButton.TabIndex = 2;
		this.errorListButton.Text = "Error list...";
		this.errorListButton.Click += new System.EventHandler(this.errorListButton_Click);
		// 
		// simpleViewButton
		// 
		this.simpleViewButton.Location = new System.Drawing.Point(24, 16);
		this.simpleViewButton.Name = "simpleViewButton";
		this.simpleViewButton.TabIndex = 1;
		this.simpleViewButton.Text = "Simple...";
		this.simpleViewButton.Click += new System.EventHandler(this.simpleViewButton_Click);
		// 
		// saveButton
		// 
		this.saveButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
		this.saveButton.Location = new System.Drawing.Point(440, 16);
		this.saveButton.Name = "saveButton";
		this.saveButton.TabIndex = 0;
		this.saveButton.Text = "Save...";
		this.saveButton.Click += new System.EventHandler(this.saveButton_Click);
		// 
		// splitter2
		// 
		this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
		this.splitter2.Location = new System.Drawing.Point(0, 152);
		this.splitter2.Name = "splitter2";
		this.splitter2.Size = new System.Drawing.Size(525, 3);
		this.splitter2.TabIndex = 1;
		this.splitter2.TabStop = false;
		// 
		// mimeTreeView
		// 
		this.mimeTreeView.Dock = System.Windows.Forms.DockStyle.Top;
		this.mimeTreeView.ImageIndex = -1;
		this.mimeTreeView.Location = new System.Drawing.Point(0, 0);
		this.mimeTreeView.Name = "mimeTreeView";
		this.mimeTreeView.SelectedImageIndex = -1;
		this.mimeTreeView.Size = new System.Drawing.Size(525, 152);
		this.mimeTreeView.TabIndex = 0;
		this.mimeTreeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.mimeTreeView_AfterSelect);
		// 
		// MainForm
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(728, 449);
		this.Controls.Add(this.panel1);
		this.Controls.Add(this.splitter1);
		this.Controls.Add(this.mailListView);
		this.Controls.Add(this.statusBar);
		this.Menu = this.mainMenu;
		this.Name = "MainForm";
		this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
		this.Text = "Example2";
		this.panel1.ResumeLayout(false);
		this.panel3.ResumeLayout(false);
		this.mailPanel.ResumeLayout(false);
		this.panel2.ResumeLayout(false);
		this.ResumeLayout(false);

	}
	#endregion

	[STAThread]
	static void Main() 
	{
		Application.Run(new MainForm());
	}

	private void selectFolderMenuItem_Click(object sender, System.EventArgs e)
	{
		if (this.folderBrowserDialog.ShowDialog()==DialogResult.OK)
		{
			//read all *.eml files in this folder.
			DirectoryInfo di=new DirectoryInfo(this.folderBrowserDialog.SelectedPath);
			FileInfo[] fiArray=di.GetFiles("*.eml");
			this.mailListView.BeginUpdate();
			this.mailListView.Items.Clear();
			ListViewItem item;
			for(int i=0;i<fiArray.Length;i++)
			{
				item=new ListViewItem(fiArray[i].Name);
				item.Tag=fiArray[i];
				this.mailListView.Items.Add(item);
			}
			this.mailListView.EndUpdate();
		}
	}

	void ProcessMime(MimeBase mime,TreeNode root)
	{
		TreeNode newRoot=root.Nodes.Add(mime.ContentType.ToString());
		Type type=mime.GetType();

		if (type==typeof(MimeData))
		{
			newRoot.Tag=mime;
		}
		else
		if (type==typeof(MimeRelated))
		{
			MimeRelated m=(MimeRelated)mime;
			ProcessMime(m.Root,newRoot);
			foreach(MimeBase part in m.Parts)
				ProcessMime(part,newRoot);
		}
		else
		// all others, derived from MimeMultipart
		if (type.BaseType==typeof(MimeMultipart))
		{
			MimeMultipart m=(MimeMultipart)mime;
			foreach(MimeBase part in m.Parts)
				ProcessMime(part,newRoot);
		}
	}

	private void ProcessMessage()
	{
		subject.Text=from.Text="";
		this.toListBox.Items.Clear();
		this.ccListBox.Items.Clear();


		if (mail.Subject!=null)
			this.subject.Text=mail.Subject;
		
		this.from.Text=mail.From.ToString();
		
		foreach(MailBox m in mail.To)
			this.toListBox.Items.Add(m.ToString());

		foreach(MailBox m in mail.Cc)
			this.ccListBox.Items.Add(m.ToString());
		
		this.mimeTreeView.Nodes.Clear();
		TreeNode root=this.mimeTreeView.Nodes.Add("root");
        ProcessMime(this.mail.Mime,root);
		this.mimeTreeView.ExpandAll();
	}

	private void mailListView_SelectedIndexChanged(object sender, System.EventArgs e)
	{
		if (this.mailListView.SelectedItems.Count==0)
			return;
		
		ListViewItem item=this.mailListView.SelectedItems[0];
		if (item.Tag.GetType()==typeof(FileInfo))
		{
			
			FileStream stream=((FileInfo)item.Tag).OpenRead();
			StreamReader sr=new StreamReader(stream,Encoding.Default);
			try
			{
				string s=sr.ReadToEnd();
				
				mail=MailMessage.Parse(s);

				//mail=MailMessage.Parse(sr.ReadToEnd());
			}
			catch(MailException ex)
			{
				MessageBox.Show(ex.ToString());
				return;
			}
		}
		else
			mail=(MailMessage)item.Tag;
		
		ProcessMessage();
	}

	private void mimeTreeView_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
	{
		if (e.Node.Parent==null)	//mail's info
		{
			this.mailPanel.BringToFront();
			return;
		}
		if (e.Node.Tag==null)		//'multipart/?'
			return;

		MimeData m=(MimeData)e.Node.Tag;

		if (this.pictureBox.Image!=null)	
		{
			this.pictureBox.Image.Dispose();
			this.pictureBox.Image=null;
		}

		if (m.ContentType.MimeType==MimeType.Image) //image
		{
			this.pictureBox.BringToFront();
			this.pictureBox.Image=Image.FromStream(m.GetMemoryStream());
			return;
		}
		//text
		this.textBox.BringToFront();
		this.textBox.Text=m.Body;
	}

	private void saveButton_Click(object sender, System.EventArgs e)
	{
		if (this.mimeTreeView.SelectedNode==null)
			return;
		if (this.mimeTreeView.SelectedNode.Tag==null)
			return;
		MimeData m=(MimeData)(this.mimeTreeView.SelectedNode.Tag);
		
		SaveFileDialog d=new SaveFileDialog();
		d.FileName=m.FileName;
		if (d.ShowDialog()==DialogResult.OK)
		{
			m.Save(d.FileName);
		}
	}

	private void simpleViewButton_Click(object sender, System.EventArgs e)
	{
		if (mail==null)
			return;
		SimpleMailMessage sm=new SimpleMailMessage(this.mail);
		SimpleForm f=new SimpleForm(sm);
		f.ShowDialog(this);
	}

	private void receiveMenuItem_Click(object sender, System.EventArgs e)
	{
		ServerSettings form=new ServerSettings();
		
		Pop3 pop3=new Pop3();
		if (form.ShowDialog()==DialogResult.OK)
		{
			this.mailListView.Items.Clear();

			pop3.User=form.userTextBox.Text;
			pop3.Password=form.passwordTextBox.Text;
			try
			{
				pop3.Connect(form.serverTextBox.Text);
				if (pop3.HasTimeStamp==true && form.apopCheckBox.Checked==true)
					pop3.APOPLogin();
				else
					pop3.Login();
				pop3.GetAccountStat();

				ListViewItem item;
				MailMessage mail;
				for(int i=1;i<=pop3.MessageCount;i++)
				{
					try
					{
						mail=MailMessage.Parse(pop3.GetMessage(i));
						item=new ListViewItem(mail.Subject);
						item.Tag=mail;
						this.mailListView.Items.Add(item);
					}
					catch(MailException ex)
					{
						MessageBox.Show(ex.Message);
					}
				}
			}
			catch(ServerException ex)
			{
				MessageBox.Show(ex.Message);	
			}
			finally
			{
				pop3.Close(false);
			}

		}
	}

	private void errorListButton_Click(object sender, System.EventArgs e)
	{
		if (mail==null)
			return;

		StringBuilder sb=new StringBuilder();
		if (this.mail.errorList.Count==0)
			sb.Append("Empty");
		for(int i=0;i<this.mail.errorList.Count;i++)
		{
			sb.Append(this.mail.errorList[i].Message);
			sb.Append("\r\n");
		}
		MessageBox.Show(this,sb.ToString(),"Error list",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);
	}

};

